Loading...
Searching...
No Matches
BALL::Bruker2DFile Class Reference
Molecular Modeling » File Formats » NMR File Formats

`#include <BALL/FORMAT/bruker2DFile.h>`

Inheritance diagram for BALL::Bruker2DFile:

## Public Member Functions

| Bruker2DFile ()
| Bruker2DFile (const String &name, OpenMode open_mode=std::ios::in|std::ios::binary)
virtual | ~Bruker2DFile ()
void | read ()
void | read (const String &name)
const RegularData2D & | getData () const
| Return a reference to the spectrum.
RegularData2D & | getData ()
std::list< std::pair< int, int > > | getPeakList () const
std::pair< double, double > | getShift (Position x, Position y)
std::pair< Position, Position > | getPosition (double x, double y)
void | setShiftRange (double offsetf1, double offsetf2, double swidthf1, double swidthf2, double bfreqf1, double bfreqf2, double spointnumf1, double spointnumf2)
Public Member Functions inherited from BALL::File
| File ()
| File (const String &name, OpenMode open_mode=std::ios::in)
virtual | ~File ()
virtual void | clear ()
bool | isValid () const
bool | open (const String &name, File::OpenMode open_mode=std::ios::in)
bool | reopen ()
bool | reopen (File::OpenMode open_mode)
void | close ()
const String & | getName () const
void | setName (const String &name)
const String & | getOriginalName () const
Size | getSize ()
File::OpenMode | getOpenMode () const
Type | getType (bool trace_link) const
bool | copyTo (const String &destination_name, Size buffer_size=4096)
bool | moveTo (const String &destination_name)
bool | remove ()
bool | renameTo (const String &new_path)
bool | truncate (Size size=0)
std::fstream & | getFileStream ()
TransformationManager & | getTransformationManager ()
const TransformationManager & | getTransformationManager () const
bool | operator== (const File &file) const
bool | operator!= (const File &file) const
bool | isOpen () const
bool | isClosed () const
bool | isAccessible () const
bool | isCanonized () const
bool | isReadable () const
bool | isWritable () const
bool | isExecutable () const

## Protected Attributes

JCAMPFile | parsf1_
| These classes give access to the parameters used in aqcuiring the spectrum.
JCAMPFile | parsf2_
Size | minx_
Size | maxx_
Size | miny_
Size | maxy_
RegularData2D | dat_
double | soffsetf1_
double | soffsetf2_
double | swidthf1_
double | swidthf2_
double | bfreqf1_
double | bfreqf2_
Size | spointnumf1_
Size | spointnumf2_
RegularData2D | spectrum_
String | name_
String | original_name_
OpenMode | open_mode_
bool | is_open_
bool | is_temporary_

## Additional Inherited Members

Public Types inherited from BALL::File
typedef std::ios::openmode | OpenMode
enum | Transformation { TRANSFORMATION__EXEC = 1 , TRANSFORMATION__FILTER = 2 , TRANSFORMATION__URL = 3 }
enum | Type { TYPE__UNKNOWN = 0 , TYPE__DIRECTORY = 1 , TYPE__CHAR_SPECIAL_FILE = 2 , TYPE__BLOCK_SPECIAL_FILE = 3 , TYPE__REGULAR_FILE = 4 , TYPE__SYMBOLIC_LINK = 5 , TYPE__SOCKET = 6 , TYPE__FIFO_SPECIAL_FILE = 7 }
static Size | getSize (String name)
static Type | getType (String name, bool trace_link)
static bool | copy (String source_name, String destination_name, Size buffer_size=4096)
static bool | move (const String &source_name, const String &destination_name)
static bool | remove (String name)
static bool | rename (String old_path, String new_path)
static bool | truncate (String path, Size size=0)
static bool | createTemporaryFilename (String &temporary, const String &suffix=".TMP")
static void | enableTransformation (Transformation transformation)
static void | disableTransformation (Transformation transformation)
static bool | isTransformationEnabled (Transformation transformation)
static void | registerTransformation (const String &pattern, const String &exec)
static void | unregisterTransformation (const String &pattern)
static bool | isAccessible (String name)
static bool | isReadable (String name)
static bool | isWritable (String name)
static bool | isExecutable (String name)
Static Public Attributes inherited from BALL::File
static const OpenMode | MODE_IN
| Open for input (default).
static const OpenMode | MODE_OUT
| Open for output.
static const OpenMode | MODE_APP
| Append. Seek to end before each write operation.
static const OpenMode | MODE_BINARY
| Binary mode.
static const OpenMode | MODE_ATE
| Seek to end directly after opening.
static const OpenMode | MODE_TRUNC
| Truncate an existing file.
static const String | TRANSFORMATION_EXEC_PREFIX
| Prefix for filenames that are created through the execution of commands "exec:".
static const String | TRANSFORMATION_FILE_PREFIX
| Prefix for files (to mimick URL-like behavior) "file:".
static const String | TRANSFORMATION_FTP_PREFIX
| Prefix for FTP-transfers "ftp://".
static const String | TRANSFORMATION_HTTP_PREFIX
| Prefix for HTTP-transfer "http://".
static HashSet< String > | created_temp_filenames_
static TransformationManager | transformation_manager_
static Size | transformation_methods_

## Detailed Description

Bruker 2D spectrum format. A class for reading Bruker two-dimensional NMR spectra.

Definition at line 24 of file bruker2DFile.h.

## Constructor & Destructor Documentation

## Bruker2DFile() [1/2]

BALL::Bruker2DFile::Bruker2DFile | ( |  | ) |

Default constructor.

## Bruker2DFile() [2/2]

BALL::Bruker2DFile::Bruker2DFile | ( | const String & | name,
|  | OpenMode | open_mode = std::ios::in|std::ios::binary )

Constructor.

Parameters

  name | important: name of the Bruker-*directory*

Exceptions

  Exception::FileNotFound | if the file could not be opened

## ~Bruker2DFile()

virtual BALL::Bruker2DFile::~Bruker2DFile | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## getData() [1/2]

RegularData2D & BALL::Bruker2DFile::getData | ( |  | ) |

inline

Definition at line 56 of file bruker2DFile.h.

## getData() [2/2]

const RegularData2D & BALL::Bruker2DFile::getData | ( |  | ) | const

inline

Return a reference to the spectrum.

Definition at line 54 of file bruker2DFile.h.

## getPeakList()

std::list< std::pair< int, int > > BALL::Bruker2DFile::getPeakList | ( |  | ) | const

Returns a list of peaks found in the spectrum.

## getPosition()

std::pair< Position, Position > BALL::Bruker2DFile::getPosition | ( | double | x,
|  | double | y )

Returns the coordinates of a point in the original data next to the given coordinates.

## getShift()

std::pair< double, double > BALL::Bruker2DFile::getShift | ( | Position | x,
|  | Position | y )

Returns the shift corresponding to a position in the bitmap.

## read() [1/2]

void BALL::Bruker2DFile::read | ( |  | ) |

Read a spectrum. It will be stored in spectrum_;

## read() [2/2]

void BALL::Bruker2DFile::read | ( | const String & | name | ) |

Read a spectrum from "name". It will be stored in spectrum_;

## setShiftRange()

void BALL::Bruker2DFile::setShiftRange | ( | double | offsetf1,
|  | double | offsetf2,
|  | double | swidthf1,
|  | double | swidthf2,
|  | double | bfreqf1,
|  | double | bfreqf2,
|  | double | spointnumf1,
|  | double | spointnumf2 )

Set the parameters needed for conversion index<->shift.

## Member Data Documentation

## bfreqf1_

double BALL::Bruker2DFile::bfreqf1_

protected

Definition at line 94 of file bruker2DFile.h.

## bfreqf2_

double BALL::Bruker2DFile::bfreqf2_

protected

Definition at line 95 of file bruker2DFile.h.

## dat_

RegularData2D BALL::Bruker2DFile::dat_

protected

Definition at line 89 of file bruker2DFile.h.

## maxx_

Size BALL::Bruker2DFile::maxx_

protected

Definition at line 84 of file bruker2DFile.h.

## maxy_

Size BALL::Bruker2DFile::maxy_

protected

Definition at line 86 of file bruker2DFile.h.

## minx_

Size BALL::Bruker2DFile::minx_

protected

Definition at line 83 of file bruker2DFile.h.

## miny_

Size BALL::Bruker2DFile::miny_

protected

Definition at line 85 of file bruker2DFile.h.

## parsf1_

JCAMPFile BALL::Bruker2DFile::parsf1_

protected

These classes give access to the parameters used in aqcuiring the spectrum.

Definition at line 80 of file bruker2DFile.h.

## parsf2_

JCAMPFile BALL::Bruker2DFile::parsf2_

protected

Definition at line 81 of file bruker2DFile.h.

## soffsetf1_

double BALL::Bruker2DFile::soffsetf1_

protected

Definition at line 90 of file bruker2DFile.h.

## soffsetf2_

double BALL::Bruker2DFile::soffsetf2_

protected

Definition at line 91 of file bruker2DFile.h.

## spectrum_

RegularData2D BALL::Bruker2DFile::spectrum_

protected

Definition at line 98 of file bruker2DFile.h.

## spointnumf1_

Size BALL::Bruker2DFile::spointnumf1_

protected

Definition at line 96 of file bruker2DFile.h.

## spointnumf2_

Size BALL::Bruker2DFile::spointnumf2_

protected

Definition at line 97 of file bruker2DFile.h.

## swidthf1_

double BALL::Bruker2DFile::swidthf1_

protected

Definition at line 92 of file bruker2DFile.h.

## swidthf2_

double BALL::Bruker2DFile::swidthf2_

protected

Definition at line 93 of file bruker2DFile.h.